<style media="screen" type="text/css">
    /*@#page-include#(commonMine.css)*/
</style>

<p id="introText">
    Na ovoj stranici vidjet ćemo kako ostvariti registar uporabom bistabila.
</p>

<hr>


<div class="basicText">
    <p>
        Što je registar? Registar je sekvencijski modul ostvaren bistabilima. Registar može imati <i>n</i> &ndash;
        bitova i tako pamtiti <i>n</i> &ndash; bitne binarne riječi. Dakle, registar (engl. <i>register</i>) je skup
        povezanih bistabila koji u cjelini pamte određen broj bitova.
    </p>
</div>

<hr>
<div class="header">
    Primjer 1.
</div>

<div class="basicText">
    Na sljedećoj simulaciji nalazi se jedan registar. Od mnogih izvedbi registara, za početak ćemo pogledati jednostavan
    registar koji ima paralelne ulaze i paralelne izlaze. Registar prikazan u simulaciji u nastavku ima sljedeće
    karakteristike.
</div>

<hr>
<ul class="listStyle">
    <li>Djeluje samo na padajući brid signala takta.</li>
    <li>Broj bistabila od kojih se registar sastoji je 4.</li>
    <li>Vrijednost na svim ulazima i izlazima je 0.</li>
    <li>Dekodirano stanje izlaza prikazuje se iznad registra.</li>
</ul>
<hr>
<p class="basicText">
    Od navedenih svojstava simulacije možete mijenjati sve osim prvoga. Broj bistabila možete promijeniti klikom na
    kućicu u desnom gornjem dijelu simulacije (lijevom tipkom miša broj bistabila se povećava; desnom se smanjuje).
    <br><br>
    Trenutno stanje ulaza možete promijeniti klikom na odgovarajuću kućicu ulaza prikazanog registra. Ulazi su označeni
    slovom \(D\) i numerirani indeksima od \(0 \) do \(n - 1\), gdje broj \(n\) predstavlja trenutni broj bistabila.
    Gledajući s lijeva na desno, težine bitova idu od većih (npr. \(D_3\)) prema manjim (npr. \(D_{0}\)).
    <br><br>
    Kako biste dovedeni podatak s ulaza prenijeli na izlaz, možete mijenjati signal takta i tako dovesti padajući brid
    ovom registru. To možete ostvariti klikajući na kućicu <b>CP</b>-a, koja se nalazi na lijevoj strani registra.
    <br><br>
    Isprobajte ovu simulaciju tako da dovedete binarne kombinacije <code>0011</code> (\(D_3 D_2 D_1 D_0 = 0011\)) i
    <code>1010</code> (\(D_3 D_2 D_1 D_0 = 1010\)) na ulaze ovog registra te napravite odgovarajuću pobudu kako bi sklop
    ove kombinacije prebacio na izlaz.
    Nakon što ste podesili određenu kombinaciju pri vrhu ove simulacije moći ćete vidjeti binarni i dekadski broj koji
    se trenutno nalazi na izlazu. Ako ste prethodne kombinacije dobro upisali, na dekoderu ste trebali vidjeti broj
    \(3\) odnosno \(10\).
</p>

<hr>
<div align="center">
    <canvas id="registers" width="900" height="500"></canvas>
</div>

<hr>
<p class="basicText">
    Prethodna simulacija ujedno je i implementacija ovog registra. Da biste otkrili kako ovaj registar radi iznutra,
    dovoljno je kliknuti na desnu tipku miša bilo gdje unutar pravokutnika koji opisuje ovaj registar (na isti način
    možete se vratiti u pogled crne kutije ovog sklopa).

    <br><br>
    Sada pogledajte kako je registar izgrađen. Pritiskom na desnu tipku miša (unutar pravokutnika registra) pokazat će
    Vam se jedna moguća implementacija ovog registra. Jednom kada ste u pogledu implementacije ovog registra uočite da i
    dalje možete klikati ulaze \(D\), signal takta (odnosno CP) i mijenjati broj bistabila (u ovom pogledu na
    raspolaganju Vam je maksimalno 8 bistabila; za razliku od pogleda crne kutije gdje možete isprobati i registar od 20
    bitova).
    <br><br>
    Pretpostavljajući da je broj bistabila simulacije 4, isprobajte sljedeće.
    Postavite jednu kombinaciju na ulaze ovako prikazanog registra (npr. <code>0111</code>) te pogledajte što će se
    dogoditi kada na ulaz CP dovedemo padajući brid signala takta. Ako se sjećate kako radi bistabil <b>D</b> možete
    vidjeti da će ovaj registar svoje ulaze preslikati na izlaze preko bistabila <b>D</b> koji djeluju na padajući brid
    signala takta. Isprobajte podesiti ovu kombinaciju na izlaz i uvjerite se da radi. Dekoder bi sada trebao pokazivati
    broj \(7\).

</p>
<hr>

<div class="mlNote">

    <p class="warningHeader">Napomena</p>
    <p class="warning">

        Ako želite dalje isprobavati simulaciju pripazite samo na ograničenja. Ako ste u pogledu crne kutije i imate
        više od 8 bistabila, prelaskom u pogled implementacije gubite sve podatke i imate na raspolaganju 4 bistabila. U
        svim ostalim slučajevima prelaskom iz pogleda crne kutije u pogled implementacije ne gubite dovedene vrijednosti
        na ulaze, ulaz za signala takta i trenutne vrijednosti na izlazima sklopa.

        <br><br>
        Gornja napomena vrijedi za sve daljnje simulacije ako nije drugačije navedeno.

    </p>


</div>

<hr>
<p id="outroText">
    Na ovoj stranici upoznali smo se s općim registrom. Vidjeli ste njegovu jednostavnu izvedbu s bistabilima D te
    isprobali kako se ponaša. Na sljedećoj stranici vidjet ćemo kako ostvariti posmični registar.


</p>

<script>
    /*@#page-include#(library.js)*/
    /*@#page-include#(registerExample.js)*/
</script>